;******************************************************************************
;CH12-DOS.lsp..................................................................
;Konstruktionsbuero W. MEYER, D-85649 OTTERLOH, 22.09.97.........
;SUCHEN UND ERSETZEN VON VORGEGEBENEN ZEICHENFOLGEN............................
;IN MASSTEXTen, TEXTen, MTEXTen................................................
;EINGABE DER "SUCHEN"/"ERSETZE MIT" ZEICHENFOLGEN IN ZEILE 76 bis 90...........
;******************************************************************************
(defun CH12 (/ )
 (if (= sset nil)
  (progn
   (princ "\nWAEHLE DIE ZU EDITIERENDEN MASSTEXTe, TEXTe, MTEXTe. ")
   (setq sset (ssget "X" (list (cons -4 "<or")
                               (cons  0 "TEXT")
                               (cons  0 "DIMENSION")
                               (cons  0 "MTEXT")
                               (cons -4 "or>")
   )          )      )
  )
 )
 (setq sslen (sslength sset))
 (while (>= (setq sslen (1- sslen)) 0 )
  (setq ent (ssname sset sslen))
  (entmod (entget ent))
  (setq ent  (entget ent))
;------------------------------------------------------------------------------
  (setq o_str o_strbt)				       ;alte Zeichenfolge
  (setq o_slen (strlen o_str))
;------------------------------------------------------------------------------
  (if (= "DIMENSION" (cdr (assoc 0 ent)))
   (setq n_str n_strb)				       ;neue Zeichenfolge
  )
  (if (= "TEXT" (cdr (assoc 0 ent)))
    (setq n_str n_strt)
  )
  (if (= "MTEXT" (cdr (assoc 0 ent)))
      (setq n_str n_strt)
  )
  (setq n_slen (strlen n_str))
;------------------------------------------------------------------------------
  (setq si 1)
  (setq s_temp (cdr (assoc 1 ent)))
  (while (= o_slen (strlen (setq st (substr s_temp si o_slen))))
   (if (= st o_str)
    (progn
     (setq s_temp (strcat
                   (if (> si 1) (substr s_temp 1 (1- si)) "" )
                   n_str (substr s_temp (+ si o_slen))
     )            )
     (setq si (+ si n_slen))
    )
    (setq si (1+ si))
   )
  )
  (entmod (subst (cons 1 s_temp) (assoc 1 ent) ent))
 )
 (princ)
)
;******************************************************************************
(defun c:CH12-DOS (/ sslen ent o_str o_strbt o_slen n_str n_strb n_strt n_slen chf si s_temp o_slen st)
;------------------------------------------------------------------------------
 (command "_UNDO" "_m")(terpri)(terpri)
 (defun *error* (msg)
  (setq sset nil sslen nil ent nil o_str nil o_strbt nil o_slen nil n_str nil
   n_strb nil n_strt nil n_slen nil chf nil si nil s_temp nil o_slen nil st nil
  )
  (princ msg)(princ)
 )
 (setvar "cmdecho" 0)

;;;Betr. die Zeilen 76 bis 90
;;;das Semikolon am Anfang der Zeile entfernen
;;;die "suche" Zeichenfolge eingeben
;;;die "ersetze mit" Zeichenfolge eingeben 2x
;;;es knnen weitere Zeilen angefgt werden

;;;            "suche"        "ersetze mit"
 ;(setq o_strbt "%%237" n_strb "%%c" n_strt "%%c")(CH12) ;%%c=Durchmesser-Zeichen
 ;(setq o_strbt "%%154" n_strb ""   n_strt "")  (CH12)
 ;(setq o_strbt "%%129" n_strb ""   n_strt "")  (CH12)
 ;(setq o_strbt "%%225" n_strb ""   n_strt "")  (CH12)
 ;(setq o_strbt "%%132" n_strb ""   n_strt "")  (CH12)
 ;(setq o_strbt "%%148" n_strb ""   n_strt "")  (CH12)
 ;(setq o_strbt "oe" n_strb "rt" n_strt "rt")(CH12)
 ;(setq o_strbt "" n_strb "" n_strt "")(CH12)
 ;(setq o_strbt "" n_strb "" n_strt "")(CH12)
 ;(setq o_strbt "" n_strb "" n_strt "")(CH12)
 ;(setq o_strbt "" n_strb "" n_strt "")(CH12)
 ;(setq o_strbt "" n_strb "" n_strt "")(CH12)
 ;(setq o_strbt "" n_strb "" n_strt "")(CH12)
 ;(setq o_strbt "" n_strb "" n_strt "")(CH12)


 (princ "FERTIG ")
 (setq sset nil)
 (princ)
)
;******************************************************************************
(princ "\nSUCHEN UND ERSETZEN VON VORGEGEBENEN ZEICHENFOLGEN ")
(princ "\nIN MASSTEXTen, TEXTen, MTEXTen" )
(princ "Starten mit: CH12-DOS ")
